require_relative "../../../base"

require "vagrant/util/template_renderer"

describe "templates/guests/fedora/network_static6" do
  let(:template) { "guests/fedora/network_static6" }

  it "renders the template" do
    result = Vagrant::Util::TemplateRenderer.render(template, options: {
      device:  "en0",
      ip:      "fc00::10/64"
    })
    expect(result).to eq <<-EOH.gsub(/^ {6}/, "")
      #VAGRANT-BEGIN
      # The contents below are automatically generated by Vagrant. Do not modify.
      NM_CONTROLLED=no
      BOOTPROTO=static
      ONBOOT=yes
      IPV6INIT=yes
      IPV6ADDR=fc00::10/64
      DEVICE=en0
      #VAGRANT-END
    EOH
  end
end
